Index: t3lib/class.t3lib_tceforms_inline.php
===================================================================
--- t3lib/class.t3lib_tceforms_inline.php	(Revision 3635)
+++ t3lib/class.t3lib_tceforms_inline.php	(Arbeitskopie)
@@ -418,8 +418,8 @@
 		}
 
 			// set the record container with data for output
-		$out = '<div id="'.$formFieldNames.'_header">'.$header.'</div>';
-		$out .= '<div id="'.$formFieldNames.'_fields"'.$appearanceStyleFields.'>'.$fields.$combination.'</div>';
+		$out = '<div id="'.$formFieldNames.'_header" class="inlineHeaderDiv">'.$header.'</div>';
+		$out.= '<div id="'.$formFieldNames.'_fields"'.$appearanceStyleFields.' class="inlineFieldsDiv">'.$fields.$combination.'</div>';
 			// wrap the header, fields and combination part of a child record with a div container
 		$class = 'inlineDiv'.($this->fObj->clientInfo['BROWSER']=='msie' ? 'MSIE' : '').($isNewRecord ? ' inlineIsNewRecord' : '');
 		$out = '<div id="'.$formFieldNames.'_div" class="'.$class.'">' . $out . '</div>';
@@ -470,7 +470,7 @@
 			// Init:
 		$formFieldNames = $this->inlineNames['object'].'['.$foreign_table.']['.$rec['uid'].']';
 		$expandSingle = $config['appearance']['expandSingle'] ? 1 : 0;
-		$onClick = "return inline.expandCollapseRecord('".htmlspecialchars($formFieldNames)."', $expandSingle)";
+		$onClick = "this.blur(); return inline.expandCollapseRecord('".htmlspecialchars($formFieldNames)."', $expandSingle)";
 
 			// Pre-Processing:
 		$isOnSymmetricSide = t3lib_loadDBGroup::isOnSymmetricSide($parentUid, $config, $rec);
@@ -528,7 +528,7 @@
 
 			// @TODO: Check the table wrapping and the CSS definitions
 		$header =
-			'<table cellspacing="0" cellpadding="0" border="0" width="100%" style="margin-right: '.$this->inlineStyles['margin-right'].'px;"'.
+			'<table cellspacing="0" cellpadding="0" border="0" width="100%"'.
 			($this->fObj->borderStyle[2] ? ' background="'.htmlspecialchars($this->backPath.$this->fObj->borderStyle[2]).'"':'').
 			($this->fObj->borderStyle[3] ? ' class="'.htmlspecialchars($this->fObj->borderStyle[3]).'"':'').'>' .
 			'<tr class="class-main12"><td width="18">'.$iconImg.'</td><td align="left"><b>'.$label.'</b></td><td align="right">'.$ctrl.'</td></tr></table>';
@@ -1931,8 +1931,6 @@
 	 * @return	string		The wrapped HTML code
 	 */
 	function wrapFormsSection($section, $styleAttrs = array(), $tableAttrs = array()) {
-		if (!$styleAttrs['margin-right']) $styleAttrs['margin-right'] = $this->inlineStyles['margin-right'].'px';
-
 		foreach ($styleAttrs as $key => $value) $style .= ($style?' ':'').$key.': '.htmlspecialchars($value).'; ';
 		if ($style) $style = ' style="'.$style.'"';
 
Index: typo3/stylesheet.css
===================================================================
--- typo3/stylesheet.css	(Revision 3635)
+++ typo3/stylesheet.css	(Arbeitskopie)
@@ -1037,6 +1037,27 @@
 	display: inline-block;
 }
 
+.typo3-TCEforms div.inlineDiv {
+	margin: 0 5px 5px 0;
+}
+
+.typo3-TCEforms div.inlineDiv > div.inlineFieldsDiv {
+	padding: 0 5px;
+	border-width: 0 1px 1px;
+	border-style: dotted;
+	border-color: #555;
+}
+
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable,
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable1,
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable2,
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable3,
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable4,
+.typo3-TCEforms div.inlineDiv > div.inlineHeaderDiv > table.wrapperTable5 {
+	margin: 0;
+	border: none;
+}
+
 /* Element Browser / RTE link selection: */
 
 table#typo3-curUrl {
Index: typo3/sysext/t3skin/stylesheets/typo3-TCEforms.css
===================================================================
--- typo3/sysext/t3skin/stylesheets/typo3-TCEforms.css	(Revision 3635)
+++ typo3/sysext/t3skin/stylesheets/typo3-TCEforms.css	(Arbeitskopie)
@@ -156,3 +156,14 @@
 TABLE.typo3-TCEforms TABLE.wrapperAttention .wrapperTable5 {
 	border: 1px solid #A30904;
 	}
+
+
+/* - - - - - - - - - - - - - - - - - - - - -
+
+TCEforms Inline-Relational-Record-Editing
+
+- - - - - - - - - - - - - - - - - - - - - */
+
+.typo3-TCEforms div.inlineDiv > div.inlineFieldsDiv {
+	border-color: #A2AAB8;
+}