Index: typo3/db_list.php
===================================================================
--- typo3/db_list.php	(revision 3741)
+++ typo3/db_list.php	(working copy)
@@ -175,9 +175,14 @@
 
 			// Loading module configuration:
 		$this->modTSconfig = t3lib_BEfunc::getModTSconfig($this->id,'mod.'.$this->MCONF['name']);
-
+	
 			// Clean up settings:
 		$this->MOD_SETTINGS = t3lib_BEfunc::getModuleData($this->MOD_MENU, t3lib_div::_GP('SET'), $this->MCONF['name']);
+
+			// override MOD_SETTINGS from page TSconfig if the according checkbox is disabled
+		$this->MOD_SETTINGS['bigControlPanel'] = $this->modTSconfig['properties']['enableExtendedView']&&$this->modTSconfig['properties']['disableBigControlPanelCheckbox']?1:$this->MOD_SETTINGS['bigControlPanel'];
+		$this->MOD_SETTINGS['clipBoard'] = $this->modTSconfig['properties']['enableClipBoard']&&$this->modTSconfig['properties']['disableClipBoardCheckbox']?1:$this->MOD_SETTINGS['clipBoard'];
+		$this->MOD_SETTINGS['localization'] = $this->modTSconfig['properties']['enableLocalizationView']&&$this->modTSconfig['properties']['disableLocalizationCheckbox']?1:$this->MOD_SETTINGS['localization'];
 	}
 
 	/**
@@ -230,6 +235,10 @@
 		$dblist->allowedNewTables = t3lib_div::trimExplode(',', $this->modTSconfig['properties']['allowedNewTables'], 1);
 		$dblist->deniedNewTables = t3lib_div::trimExplode(',', $this->modTSconfig['properties']['deniedNewTables'], 1);
 		$dblist->newWizards=$this->modTSconfig['properties']['newWizards']?1:0;
+		$dblist->disableSearchBox = $this->modTSconfig['properties']['disableSearchBox']?1:0;
+		$dblist->disableBigControlPanelCheckbox = $this->modTSconfig['properties']['disableBigControlPanelCheckbox']?1:0;
+		$dblist->disableClipBoardCheckbox = $this->modTSconfig['properties']['disableClipBoardCheckbox']?1:0;
+		$dblist->disableLocalizationCheckbox = $this->modTSconfig['properties']['disableLocalizationCheckbox']?1:0;
 		$dblist->pageRow = $this->pageinfo;
 		$dblist->counter++;
 		$dblist->MOD_MENU = array('bigControlPanel' => '', 'clipBoard' => '', 'localization' => '');
@@ -368,7 +377,7 @@
 				$this->body.=$dblist->fieldSelectBox($dblist->table);
 			}
 
-				// Adding checkbox options for extended listing and clipboard display:
+			// Adding checkbox options for extended listing and clipboard display:
 			$this->body.='
 
 					<!--
@@ -377,11 +386,15 @@
 					<div id="typo3-listOptions">
 						<form action="" method="post">';
 
-			$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[bigControlPanel]',$this->MOD_SETTINGS['bigControlPanel'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLargeControl"').' <label for="checkLargeControl">'.$LANG->getLL('largeControl',1).'</label><br />';
-			if ($dblist->showClipboard)	{
+			if (!$dblist->disableBigControlPanelCheckbox) {
+				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[bigControlPanel]',$this->MOD_SETTINGS['bigControlPanel'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLargeControl"').' <label for="checkLargeControl">'.$LANG->getLL('largeControl',1).'</label><br />';
+			}
+			if ($dblist->showClipboard && !$dblist->disableClipBoardCheckbox)	{
 				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[clipBoard]',$this->MOD_SETTINGS['clipBoard'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkShowClipBoard"').' <label for="checkShowClipBoard">'.$LANG->getLL('showClipBoard',1).'</label><br />';
 			}
-			$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[localization]',$this->MOD_SETTINGS['localization'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLocalization"').' <label for="checkLocalization">'.$LANG->getLL('localization',1).'</label><br />';
+			if (!$dblist->disableLocalizationCheckbox) {
+				$this->body.=t3lib_BEfunc::getFuncCheck($this->id,'SET[localization]',$this->MOD_SETTINGS['localization'],'db_list.php',($this->table?'&table='.$this->table:''),'id="checkLocalization"').' <label for="checkLocalization">'.$LANG->getLL('localization',1).'</label><br />';
+			}
 			$this->body.='
 						</form>
 					</div>';
@@ -393,8 +406,10 @@
 				$this->body.= t3lib_BEfunc::cshItem('xMOD_csh_corebe', 'list_clipboard', $GLOBALS['BACK_PATH']);
 			}
 
-				// Search box:
-			$this->body.=$dblist->getSearchBox();
+				// Display search box, if not disabled:
+			if (!$dblist->disableSearchBox) {				
+				$this->body.=$dblist->getSearchBox();
+			}
 
 				// Display sys-notes, if any are found:
 			$this->body.=$dblist->showSysNotesForPage();